//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****   JScript project dark_do_traverse_dark.jsp                                                      *****
//*****                                                                                                  *****
//*****   ACTION                                                                                         *****
//*****                                                                                                  *****
//*****   Version 3.0 / 27 February, 2009                                                                *****
//*****                                                                                                  *****
//*****   Author V.I. Tsanev (vip20@cam.ac.uk)                                                           *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** Clear spectrum bar ***********************************************************************************
//*****                                                                                                  *****

        Specbar.CloseAllSpectra()  

//*****                                                                                                  *****
//***** Create the work folder - if it exists terminate the script *******************************************
//*****                                                                                                  *****

        fldr = "c:\\work\\ooi\\" + CommonSpectrumPrefix + "\\"                  ;
        ReportFolderStatus(fldr)                                      ;
		if (fldrEXISTS == 1) 
		     { 
		       Console.WriteLine("KEY = " + fldrEXISTS +" folder " + fldr + " exists")        ;
		       Console.WriteLine("")                                                          ;
		       Console.WriteLine("Script terminated!")                                        ; 
		       Process.Start("C:\\work\\beep.exe")                                            ;   
		     }
		else 
		     { 
			   Console.WriteLine("KEY = " + fldrEXISTS +" folder " + fldr + " just created ") ; 
			   WORKfolder = fso.CreateFolder(fldr);

//*****                                                                                                  *****
//************************************************************************************************************
//*****  

	           datata = Datum()                                              ;
               uiwWriter.Status = ""
			   ResName = "" + fldr+CommonSpectrumPrefix + "_protocol.csv"    ; 
               ioRes = fso.CreateTextFile(ResName,true)                      ;
               ioRes.WriteLine( "Experiment"   + "," +   experimentID + "" ) ;
	           ioRes.WriteLine( "Location"     + "," +     locationID + "" ) ;
	           ioRes.WriteLine( "Date"         + "," +         datata + "" ) ;
               ioRes.WriteLine( "Spectrometer" + "," + spectrometerID + "" ) ;
	           ioRes.WriteLine( "Data folder"  + "," +           fldr + "" ) ;
	           ioRes.WriteLine( "Author"       + "," +       authorID + "" ) ;
	           ioRes.WriteLine( "")                                          ;
               ioRes.WriteLine("No,Spectrum,Time,Max_value,Quality")         ;
               ioRes.WriteLine( "") 

//*****                                                                                                  *****
//************************************************************************************************************
//*****  

               ListName = "" + fldr+CommonSpectrumPrefix + "_list.txt"       ;
			   TempName = "" + fldr+CommonSpectrumPrefix + "_temp.txt"       ;
               ioList = fso.CreateTextFile(TempName,true)                    ;
               ioList.WriteLine( "" + IndividualExpTime + "" )               ;
			   ioList.WriteLine( "" + NumberScans       + "" )               ;
	           ioList.WriteLine( "" + locationID        + "" )               ;
	           ioList.WriteLine( "" + experimentID      + "" )               ;
               ioList.WriteLine( "" + authorID          + "" )               ;

//*****                                                                                                  *****
//************ Initialize spectrometer's parameters **********************************************************
//*****                                                                                                  *****

               spectro = 1 ;
		       if ( spectrometerTYPE == "USB4000" )
		            { // USB4000 spectrometer
					  uiwWriter.Status = "USB4000 detected"; uiwWriter.Status = "" ; 
                      NumberPixels = 3648 ; MaxADCcounts = 65535 ;  
		              MinChannelToShow =0 ; MaxChannelToShow = 3647 ; }
               else if ( spectrometerTYPE == "USB2000" )  
		            { // USB2000 spectrometer
					  uiwWriter.Status = "USB2000 detected"; uiwWriter.Status = "" ;
                      NumberPixels = 2048 ; MaxADCcounts = 4095 ;  
		              MinChannelToShow =0 ; MaxChannelToShow = 2047 ; }
               else if ( spectrometerTYPE == "USB2000+" )  
		            { // USB2000+ spectrometer
					  uiwWriter.Status = "USB2000+ detected"; uiwWriter.Status = "" ;
                      NumberPixels = 2048 ; MaxADCcounts = 65535 ; 
		              MinChannelToShow =0 ; MaxChannelToShow = 2047 ; }
		       else
		            { // wrong spectrometer type           
					  uiwWriter.Status = "Wrong spectrometer type!"; uiwWriter.Status = "" ;
                      spectro = 0 ; }

//*****                                                                                                  *****

               MaxSignal = parseInt(MaxADCcounts * NumberScans) ;

//*****                                                                                                  *****
//************************************************************************************************************
//*****  

    	       Process.Start("C:\\work\\beep.exe")                           ;
			   uiwWriter.Status = ""                                         ; 
               uiwWriter.Status = "!!! Block the telescope !!!"              ;
	           Thread.Sleep(5000)                                            ;

//*****                                                                                                  *****
//************ Create the dark spectrum object and record first dark spectrum ********************************
//*****                                                                                                  *****

               DarkSpec = Specbar.GetSpectrum("Dark Spectrum")                          ;
               DarkSpec.Name       = "darkspectrum1"                                    ;
               DarkSpec.MinChannel = MinChannelToShow                                   ;
               DarkSpec.MaxChannel = MaxChannelToShow                                   ;
               DarkSpec.MathLow    = 1                                                  ;
               DarkSpec.MathHigh   = NumberPixels                                       ;

//*****                                                                                                  *****
             
               spectrograph.Scan(DarkSpec,NumberScans,IndividualExpTime )               ;
               DarkSpec.Name       = "" + DarkSpectrumName + "1"                        ;
               DarkSpec.Device     = spectrometerID                                     ;
		       DarkSpec.Author     = authorID                                           ;
               DarkSpec.UserParam1 = project                                            ;
	 		   DarkSpec.UserParam2 = version                                            ;
			   DarkSpec.UserParam3 = vip20                                              ;
		       DarkSpec.SaveAs(""+fldr+DarkSpectrumName+"1"+CommonSpectrumExtension+"") ;

//*****                                                                                                  *****

		       if (DarkSpec.Max >= MaxSignal)
		                                     quality = "Saturated"                     ;
               else
		                                     quality = "OK"                            ;
									      
               ioRes.WriteLine("d1"+","+DarkSpectrumName + "1"+","+DarkSpec.StopTime+
                               ","+DarkSpec.Max+","+quality)                            ;

//*****                                                                                                  *****

               uiwWriter.Status = "!!! Unblock the telescope for spectra recording !!!" ;
			   uiwWriter.Status = ""                                                    ;
               Process.Start("C:\\work\\beep.exe")                                      ;
		       Thread.Sleep(5000)                                                       ;

//*****                                                                                                  *****
//************ Create the measured spectrum object ***********************************************************
//*****                                                                                                  *****

               MeasSpec = Specbar.GetSpectrum("Measurement Spectrum")                   ;
               MeasSpec.MinChannel     = MinChannelToShow                               ;
               MeasSpec.MaxChannel     = MaxChannelToShow                               ;
               MeasSpec.MathLow        = 1                                              ;
               MeasSpec.MathHigh       = NumberPixels                                   ;
               MeasSpec.ChartYAxis     = "Fixed"                                        ;
               MeasSpec.ChartYAxisMin  = 0                                              ;
               MeasSpec.ChartYAxisMax  = parseInt(MaxSignal)                            ;
               MeasSpec.OverlayMode    = OverlayMode.Normal                             ;
               MeasSpec.AddOverlay(DarkSpec)                                            ;

//*****                                                                                                  *****

		       j     = 0                                                                ;

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****

               while(!Script.StopAllScripts)  // loop until stop button is used

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****

               {

//*****                                                                                                  *****

                     spectrograph.Scan(MeasSpec,NumberScans,IndividualExpTime )        ;
			         MeasSpec.Name   = "MSpec"                                         ;
			         MeasSpec.Device = spectrometerID                                  ;            
			         MeasSpec.Author = authorID                                        ;
			         MeasSpec.Site = locationID                                        ;
			         MeasSpec.Remark = experimentID                                    ;
                     MeasSpec.UserParam1 = project                                     ;
					 MeasSpec.UserParam2 = version                                     ;
					 MeasSpec.UserParam3 = vip20                                       ;
                     Specbar.CurrentSpectrum = MeasSpec                                ;

//*****                                                                                                  *****

                     nomer = ""+Count(j)+""                                            ;
			         MeasSpec.SaveAs("" + fldr + CommonSpectrumPrefix + nomer + 
			                         CommonSpectrumExtension + "")                     ;

//*****                                                                                                  *****

		             if (MeasSpec.Max >= MaxSignal)
		                                                quality = "Saturated"          ;
                     else
		                                                quality = "OK"                 ;
                     ioRes.WriteLine(j+","+CommonSpectrumPrefix + nomer + 
			                         CommonSpectrumExtension + ""+","
									 +MeasSpec.StopTime+","+MeasSpec.Max+","
									 +quality)                                         ;
                     ioList.WriteLine(j + " " + fldr + CommonSpectrumPrefix +  
			                          nomer + CommonSpectrumExtension + "")            ;
			         uiwWriter.Status = "Recorded spectrum # "+j+
			                            " : max value - "+MeasSpec.Max.toFixed()+
			                            " : max level - "+MaxSignal.toFixed()+
			                            " - "+quality+""                               ; 

//*****                                                                                                  *****

			         j++                                                               ;
               }

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****

    	       Process.Start("C:\\work\\beep.exe")                                     ;
			   uiwWriter.Status = ""                                                   ;
               uiwWriter.Status = "!!! Block the telescope !!!"                        ;
	           Thread.Sleep(5000)                                                      ;

//*****                                                                                                  *****

               spectrograph.Scan(DarkSpec,NumberScans,IndividualExpTime )              ;
               DarkSpec.Name       = "" + DarkSpectrumName + "2"                       ;
               DarkSpec.Device     = spectrometerID                                    ;
		       DarkSpec.Author     = authorID                                          ;
               DarkSpec.UserParam1 = project                                           ;
	 		   DarkSpec.UserParam2 = version                                           ;
			   DarkSpec.UserParam3 = vip20                                             ;
		       DarkSpec.SaveAs(""+fldr+DarkSpectrumName+"2"+CommonSpectrumExtension+""); 

//*****                                                                                                  *****

		       if (DarkSpec.Max >= MaxSignal*NumberScans)
		                                     quality = "Saturated"                     ;
               else
		                                     quality = "OK"                            ;

//*****                                                                                                  *****

               ioRes.WriteLine("d1"+","+DarkSpectrumName+"2"+","+DarkSpec.StopTime+
                               ","+DarkSpec.Max+","+quality)                           ;

//*****                                                                                                  *****

    	       Process.Start("C:\\work\\beep.exe")                                     ;
               uiwWriter.Status = "!!! Unlock the telescope !!!"                       ;
			   Thread.Sleep(5000)                                                      ;

//*****                                                                                                  *****
//************ Create real list file *************************************************************************
//*****                                                                                                  *****

               ioRes.WriteLine("")                                                     ;
               ioRes.WriteLine(""+project+"")                                          ;
			   ioRes.WriteLine(""+version+"")                                          ;
			   ioRes.WriteLine(""+vip20+"")                                            ;
               ioList.WriteLine("")                                                    ;
               ioList.WriteLine(""+project+"")                                         ;
			   ioList.WriteLine(""+version+"")                                         ;
			   ioList.WriteLine(""+vip20+"")                                           ;
			   ioRes.Close()                                                           ;
               ioList.Close()                                                          ;
			   ioRes  = fso.OpenTextFile(TempName, ForReading)                         ;
			   ioList = fso.CreateTextFile(ListName,true)                              ;
			   ioList.WriteLine("" + j-1 + "")                                         ;
			   for (i = 0 ; i<= j+8 ; i++)
			       { ts = ioRes.ReadLine() ; ioList.WriteLine("" + ts + "") ; }
			   ioRes.Close()                                                           ;
			   ioRes = fso.GetFile(TempName)                                           ;
               ioRes.Delete()                                                          ;
               ioList.Close()                                                          ;

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
 
               uiwWriter.Status = " "                                                  ;
			   uiwWriter.Status = "Protocol file : " + ResName                         ;
			   uiwWriter.Status = "    List File : " + ListName                        ;
			   uiwWriter.Status = " " ; uiwWriter.Status = "Ready !" 
			   uiwWriter.Status = " " ; uiwWriter.Status = ""+project+""               ;   
			   uiwWriter.Status = ""+version+""; uiwWriter.Status = ""+vip20+""        ;

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
			   
			 }               

//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
