//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****   JScript project dark_do_traverse_dark.jsp                                                      *****
//*****                                                                                                  *****
//*****   INITIALIZATION                                                                                 *****
//*****                                                                                                  *****
//*****   Version 3.0 / 27 February, 2009                                                                *****
//*****                                                                                                  *****
//*****   Author V.I. Tsanev (vip20@cam.ac.uk)                                                           *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****    NOTE:                                                                                         *****
//*****                                                                                                  *****
//*****            User has to type his inputs only in file dark_do_traverse_dark_initializattion.js     *****
//*****            in lines not ending with five starts (*****)                                          *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
        import  System             ;  // use the System libary of the .NET framework                     *****
        import  System.Threading   ;  // the .NET threading support                                      *****
		import  System.Diagnostics ;  // interact with system processes, event logs, and performance     *****
		                              // counters                                                        *****
        import  DoasCore           ;  // use the DoasCore library                                        *****
        import  DoasCore.Spectra   ;  // use the Spectra namespace                                       *****
        import  DoasCore.IO        ;  // use the Input-/Output namespace                                 *****
        import  DoasCore.Device    ;  // use the Device namespace                                        *****
        import  DoasCore.Script    ;  // use the Script namespace                                        *****
        import  DoasCore.Math      ;  // use DoasCore.Math namespace                                     *****
        import  DoasCore.HMI       ;  // Doasis Human-Machine-Interface (HMI) extensions                 *****
                                      // (only required if other input/output than the Output window     *****
                                      // is needed (Progress Bars, Status Bar))                          *****
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
        var spectrograph = new Spectrograph()                                 ; //                       *****
        var fso = new ActiveXObject("Scripting.FileSystemObject")             ; //                       *****
		var uiwWriter : UserInterfaceWriter = new UserInterfaceWriter()       ; //                       *****
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                   ********************************************************************
//***** Input data in lines below         ********************************************************************
//*****                                   ********************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** (1) Individual exposure time in ms used to record an individual spectrum                         *****
//*****                                                                                                  *****

        var IndividualExpTime       = 80 ;                                                                  

//*****                                                                                                  *****
//***** (2) Number of individual spectra to co-add in order to record a spectrum                         *****
//*****                                                                                                  *****

        var NumberScans             = 10 ;                                                                    

//*****                                                                                                  *****
//***** (3) Initialization of spectrum file names ( common file name prefix ) - STRING                   *****
//*****                                                                                                  *****

        var CommonSpectrumPrefix    = "new_short"                                                                

//*****                                                                                                  *****
//***** (4) Initialization of spectrum file names ( common file name extension ) - STRING                *****
//*****                                                                                                  *****

        var CommonSpectrumExtension = ".std"                                                              

//*****                                                                                                  *****
//***** (5) Initialization of spectrum file names ( number of digits used to assembly spectrum           *****
//*****     file names )                                                                                 *****
//*****                                                                                                  *****

        var NumberDigits            = 5 ;                                           

//*****                                                                                                  *****
//***** (6) Dark spectrum file name -  dark spectrum have the same extension as spectrum files - STRING  *****
//*****                                                                                                  *****

        var DarkSpectrumName        = "dark" ;         

//***** (7) Spectrometer type ( USB2000, USB2000+ or USB4000 are permitted, otherwise script will be     *****
//*****     be terminated ) - STRING                                                                     *****
//*****                                                                                                  *****

        var spectrometerTYPE        = "USB2000+"

//*****                                                                                                  *****
//*****  (8) Spectrometer ID (e.g. USB2G11107) - STRING                                                  *****
//*****                                                                                                  *****

        var spectrometerID          = "USB2+F00580" ; 

//*****                                                                                                  *****
//*****  (9) Short desription of thew experiment location - STRING                                       *****
//*****                                                                                                  *****

         var locationID             = "home" ; 

//*****                                                                                                  *****
//***** (10) Short desription of the experiment - STRING                                                 *****
//*****                                                                                                  *****

        var experimentID            = "testing the script" ; 

//*****                                                                                                  *****
//***** (11) Author - person performunt experiment (e.g. VIP20 ) - STRING                                *****
//*****                                                                                                  *****

        var authorID                =  "vip20"

//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
